+++
title = "提交者指南"
weight = 4
chapter = true
+++

## 提交者提名

ShardingSphere社区遵循[Apache Community’s process](http://community.apache.org/newcommitter.html) 来接收新的提交者。
当您积极地参与ShardingSphere社区之后，项目管理委员会和项目官方提交者会根据您的表现发起吸纳您成为官方提交者和项目管理委员会成员的流程。

## 提交者责任

 - 开发新功能；
 - 代码重构；
 - 及时和可靠的评审Pull Request；
 - 思考和接纳新特性请求；
 - 解答问题；
 - 维护文档和代码示例；
 - 改进流程和工具；
 - 引导新的参与者融入社区。

## 日常工作

1. 每周负责轮值的Committer需要每天查看社区待处理的Pull Request和Issue列表，负责问题的处理：

 - 包括标记issue，回复issue，关闭issue等；
 - 将issue分配至熟悉该模块的贡献者；
 - 轮值周期为一周。

2. Assignee在被分配issue后，需要进行如下判断：

 - 判断是否是长期issue，如是，则标记为pending；
 - 判断issue类型，如：bug，enhancement，discussion等；
 - 标记Milestone。

3. Committer提交的PR，需要根据PR类型和当前发布的周期标注Label和Milestone。

4. Committer review PR时，可以进行squash and merge to master的操作, 如果有问题可以加上change request或者@相关人员协助处理。

### 轮值顺序表

| 序列 | 开始时间 | 姓名   | GitHub ID     |
| ----- | ------------- | ------ | ------------- |
| 1     | 2021/8/16     | 潘娟 | tristaZero    |
| 2     | 2021/8/23     | 欧阳文 | avalon566     |
| 3     | 2021/8/30     | 蒋晓峰 | SteNicholas   |
| 4     | 2021/9/6      | 江龙滔 | RaigorJiang   |
| 5     | 2021/9/13     | 孟浩然 | menghaoranss  |
| 6     | 2021/9/20     | 端正强 | strongduanmu  |
| 7     | 2021/9/27     | 孙念君 | taojintianxia |
| 8     | 2021/10/4     | 孙念君 | taojintianxia |
| 9     | 2021/10/11    | 钟红胜 | sandynz       |
| 10    | 2021/10/18    | 兰城翔 | lanchengx     |
| 11    | 2021/10/25    | 吴伟杰 | TeslaCN       |
| 12    | 2021/11/1     | 蒋平川 | dachuan9e     |
| 13    | 2021/11/8     | 姜茂林 | jiangML       |
| 14    | 2021/11/15    | 陆敬尚 | jingshanglu   |
| 15    | 2021/11/22    | 赵锦超 | zjcnb         |
| 16    | 2021/11/29    | 陈出新 | tuichenchuxin |
| 17    | 2021/12/6     | 王波 | wbtlb         |
| 18    | 2021/12/13    | 武建东 | wujiandong    |
| 19    | 2021/12/20    | 侯阳 | soulasuna     |
| 20    | 2021/12/27    | 王小满 | wgy8283335    |