+++
title = "Committer Guide"
weight = 4
chapter = true
+++

## Committer Promotion

The ShardingSphere community follows the [Apache Community’s process](http://community.apache.org/newcommitter.html) on accepting a new committer.
After a contributor participates ShardingSphere community actively, PMC and Committers will make a decision to invite the contributor to join Committers and PMC.

## Committer Responsibilities

 - Develop new features;
 - Refactor codes;
 - Review pull requests reliably and in time;
 - Consider and accept feature requests;
 - Answer questions;
 - Update documentation and example;
 - Improve processes and tools;
 - Guide new contributors join community.


##  Committer Routine

1. Weekly rotating committers needs to check the list of pull requests and issues to be processed in the community on a daily basis.

 - Including label issue, reply issue, close issue;
 - Assign issue to the appropriate committer, namely assignee;
 - The rotation period is one week. 
 
2. After a committer is assigned with an issue, the following work is required:

 - Estimate whether it is a long-term issue. If it is, please label it as pending;
 - Add issue labels, such as bug, enhancement, discussion, etc;
 - Add milestone.
 
3. Pull request that committer submits needs to add labels and milestone based on the type and release period.

4. When committer reviewed and approved any pull request, committer could squash and merge to master. If there is any question you concerned about this pull request, please reply directly to the related issue.

### Committer rota

| Order | Starting Date | Name            | GitHub ID     |
| ----- | ------------- | --------------- | ------------- |
| 1     | 2021/8/16     | Juan Pan        | tristaZero    |
| 2     | 2021/8/23     | Yangwen Ou      | avalon566     |
| 3     | 2021/8/30     | Xiaofeng Jiang  | SteNicholas   |
| 4     | 2021/9/6      | Longtao Jiang   | RaigorJiang   |
| 5     | 2021/9/13     | Haoran Meng     | menghaoranss  |
| 6     | 2021/9/20     | Zhengqiang Duan | strongduanmu  |
| 7     | 2021/9/27     | Nianjun Sun     | taojintianxia |
| 8     | 2021/10/4     | Nianjun Sun     | taojintianxia |
| 9     | 2021/10/11    | Hongsheng Zhong | sandynz       |
| 10    | 2021/10/18    | Chengxiang Lan  | lanchengx     |
| 11    | 2021/10/25    | Weijie Wu       | TeslaCN       |
| 12    | 2021/11/1     | Pingchuan Jiang | dachuan9e     |
| 13    | 2021/11/8     | Maolin Jiang    | jiangML       |
| 14    | 2021/11/15    | Jingshang Lu    | jingshanglu   |
| 15    | 2021/11/22    | Jinchao Zhao    | zjcnb         |
| 16    | 2021/11/29    | Chuxin Chen     | tuichenchuxin |
| 17    | 2021/12/6     | Bo Wang         | wbtlb         |
| 18    | 2021/12/13    | Jiandong Wu     | wujiandong    |
| 19    | 2021/12/20    | Yang Hou        | soulasuna     |
| 20    | 2021/12/27    | Xiaoman Wang    | wgy8283335    |