+++
title = "高可用"
weight = 3
+++

## 配置入口

类名称：org.apache.shardingsphere.dbdiscovery.api.config.DatabaseDiscoveryRuleConfiguration

可配置属性：

| *名称*                      | *数据类型*                                                   | *说明*            |
| -------------------------  | ----------------------------------------------------------- | ----------------- |
| dataSources (+)            | Collection\<DatabaseDiscoveryDataSourceRuleConfiguration\>  | 数据源配置          |
| discoveryHeartbeats (+)    | Map\<String, DatabaseDiscoveryHeartBeatConfiguration\>      | 监听心跳配置        |
| discoveryTypes (+)         | Map\<String, ShardingSphereAlgorithmConfiguration\>         | 数据库发现类型配置   |

## 数据源配置

类名称：org.apache.shardingsphere.dbdiscovery.api.config.rule.DatabaseDiscoveryDataSourceRuleConfiguration

可配置属性：

| *名称*                     | *数据类型*             | *说明*                                            | *默认值*       |
| -------------------------- | -------------------- | ------------------------------------------------- | ------------- |
| groupName (+)              | String               | 数据库发现组名称                                    | -             |
| dataSourceNames (+)        | Collection\<String\> | 数据源名称，多个数据源用逗号分隔 如：ds_0, ds_1        | -             |
| discoveryHeartbeatName (+) | String               | 监听心跳名称                                        | -             |
| discoveryTypeName (+)      | String               | 数据库发现类型名称                                   | -             |

## 监听心跳配置

类名称：org.apache.shardingsphere.dbdiscovery.api.config.rule.DatabaseDiscoveryHeartBeatConfiguration

可配置属性：

| *名称*                     | *数据类型*             | *说明*                                                                 | *默认值*       |
| -------------------------- | -------------------- | ---------------------------------------------------------------------- | ------------- |
| props (+)                  | Properties           | 监听心跳属性配置，keep-alive-cron 属性配置 cron 表达式，如：'0/5 * * * * ?'  | -             |

## 数据库发现类型配置

类名称：org.apache.shardingsphere.infra.config.algorithm.ShardingSphereAlgorithmConfiguration

| *名称*                     | *数据类型*             | *说明*                                                                 | *默认值*       |
| -------------------------- | -------------------- | ---------------------------------------------------------------------- | ------------- |
| type (+)                   | String               | 数据库发现类型，如： MGR、openGauss                                       | -             |
| props (?)                  | Properties           | 数据库发现类型配置，如 MGR 的 group-name 属性配置                          | -             |
